#include <sstream>
#include "ezwin.h"
using namespace std ;

// This must be imported.
extern enum color (*fTab[])(const int, const int) ;

const int Size = 10 ;

void PlotPoints(SimpleWindow &W, enum color (*f)(const int, const int))
{
	int i, j ;
	float cellX = W.GetWidth()/Size ;
	float cellY = W.GetHeight()/Size ;

	for (i=0; i<Size; ++i)
		for (j=0; j<Size; ++j) {
			Position Pul(i*cellX, j*cellY);
			Position Plr((i+1)*cellX, (j+1)*cellY);
			enum color bColor ;
			bColor = f(i, j) ;
			W.RenderRectangle(Pul, Plr, bColor) ;
		}

}

SimpleWindow *pW;

int funcIndex = 0 ;

Position home(0.0f, 0.0f) ;

int refreshPlot()
{
	PlotPoints(*pW, fTab[funcIndex]) ;
	return 0 ;
}

int nextPlot(const Position &Ignored)
{
	pW->Close() ;
	delete pW ;
	if (fTab[++funcIndex] == NULL)
		funcIndex = 0 ;
	ostringstream winName ;
	winName << "Func " << funcIndex ;
	pW = new SimpleWindow(winName.str(), 18.0f, 18.0f, home) ;
	pW->Open() ;
	pW->SetMouseClickCallback(nextPlot) ;
	pW->SetRefreshCallback(refreshPlot) ;
	PlotPoints(*pW, fTab[funcIndex]) ;
	return 0 ;
}

int ApiMain() 
{
	pW = new SimpleWindow("Func 0", 18.0f, 18.0f, home) ;
	pW->Open() ;
	pW->SetMouseClickCallback(nextPlot) ;
	pW->SetRefreshCallback(refreshPlot) ;
	PlotPoints(*pW, fTab[0]) ;
	return 0 ;
}

int ApiEnd()
{
	pW->Close() ;
	return 0 ;
}
